#include "Status.h"
#include "Vram.h"
#include "Main.h"
// #include "Chars.h"
#include "Print.h"
#include "Knife.h"
#include "VVram.h"

constexpr ptr<byte> VramLeft = Vram + (32 - 24) / 2;

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(VramLeft + VramRowSize * 0 + 16, "SCORE"); 
    PrintS(VramLeft + VramRowSize * 3 + 16, "STAGE");
    PrintByteNumber2(VramLeft + VramRowSize * 3 + 22, CurrentStage + 1);
    PrintS(VramLeft + VramRowSize * 6 + 16, "TIME");
    {
        constexpr ptr<byte> RemainLeft = VramLeft + VramRowSize * 14 + 17;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            static const byte[] RemainChars = {
                0x80, 0x20, 0xa3, 0xaa,
            };
            pVram = Put2(pVram, RemainChars);
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(VramLeft + VramRowSize * 1 + 18, Score);
    PrintC(pVram, '0');

    // pVram = PrintNumber5(Vram + VramRowSize * 7 + 26, HiScore);
    // PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(VramLeft + VramRowSize * 6 + 21, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = VramLeft + VramRowSize * 12 + 19;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        constexpr byte Char_Knife = 0xbc;
        *pVram = Char_Knife; ++pVram;
        ++i;
        --count;
    }
    while (i != 4) {
        *pVram = ' '; ++pVram;
        ++i;
    }
}

void PrintGameOver()
{
    constexpr byte Left = (VVramWidth - 9) / 2;
    PrintS(VramLeft + VramRowSize * (VramHeight / 2) + Left, "GAME OVER");
}

void PrintTimeUp() 
{
    constexpr byte Left = (VVramWidth - 6) / 2;
    PrintS(VramLeft + VramRowSize * (VramHeight / 2) + Left, "TIME UP");
}

void Title()
{
    ClearScreen(); 
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            //	M
            0x83, 0x80, 0x80, 0x80, 
            0x83, 0x82, 0x82, 0x80, 
            0x83, 0x82, 0x82, 0x80, 
            0xab, 0xac, 0xac, 0x90, 
            //	A
            0x20, 0x80, 0x80, 0xaa, 
            0x83, 0x82, 0x20, 0x80, 
            0x83, 0x80, 0x90, 0x80, 
            0xab, 0xac, 0x20, 0x90, 
            //	Z
            0xab, 0x90, 0x80, 0x80, 
            0x20, 0xa9, 0x80, 0x20, 
            0xa9, 0x80, 0x20, 0x20, 
            0xab, 0x90, 0x90, 0x90, 
            //	Y
            0x83, 0x82, 0x83, 0x82, 
            0xab, 0x80, 0x80, 0xac, 
            0x20, 0x83, 0x82, 0x20, 
            0x20, 0xab, 0xac, 0x20, 
        };
        constexpr byte LogoLength = 4;
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = VramLeft + VramRowSize * 1;
        p = TitleBytes;
        repeat (LogoLength) {
            repeat (4) {
                repeat (4) {
                    *pVram = *p;
                    ++pVram;
                    ++p;
                }
                pVram += VramRowSize - 4;
            }
            pVram += 4 - VramRowSize * 4;
        }
        PrintS(VramLeft + VramRowSize * 5 + (VVramWidth - 4), "MINI");
    }
    PrintS(VramLeft + VramRowSize * 12 + (VVramWidth - 14) / 2, "PUSH SPACE KEY");
    PrintS(VramLeft + VramRowSize * 13 + (VVramWidth - 14) / 2, "OR 'Z' KEY");
    PrintS(VramLeft + VramRowSize * 15 + (VVramWidth - 12), "INUFUTO 2023");
    // {
    //     byte c;
    //     ptr<byte> pVram;
    //     pVram = Vram;
    //     c = 0;
    //     repeat (0) {
    //         pVram = Put(pVram, c);
    //         ++c;
    //         if ((c & 15) == 0) {
    //             pVram += VramRowSize - 16;
    //         }
    //     }
    // //     // UpdateEnemyChars();
    // //     // SwitchChars();
    // //     // while (true) {
    // //     //     ++EnemyRowLeft;
    // //     //     UpdateEnemyChars();
    // //     //     SwitchChars();
    // //     //     WaitTimer(30);
    // //     // }
    // }
}
